#if!defined _cut_off_h_

#define _cut_off_h_
#include<iostream>
using namespace std;

#include<math.h>
#include<string.h>
#include "symmetry.h"
#include "state.h"
#include "sector.h"
#include "quantum_operator.h"
#include "construction.h"

extern double allowed_error; 
extern int iteration_no;
extern double degeneracy_threshhold;

extern int *block_original_sector_array;
extern int *block_original_sector_index_array;
void get_m_star(int iteration_index,
		int max_state_no, 
	       int new_block_state_no,
	       int * m_star); 



void set_states_elimination_tags(int iteration_index,
				 int max_state_no, 
				 int state_no, 
				 state *states_array,
				 double *new_block_energies_array, 
				 double *sorted_new_block_energies_array,
				 int & kept_state_no);



void transfer_states_and_sectors(int symmetry_no, 
				 symmetry *symmetry_types,

				 int max_state_no, 
				 int kept_state_no,

				 int  new_block_state_no, 
				 state * new_block_states_array,
 
				 int  new_block_sector_no,
				 sector_properties * new_block_sectors_properties_array, 
				 
				 int & block_state_no, 
				 state * & block_states_array,

				 int & block_sector_no,
				 sector_properties * & block_sectors_properties_array,
				 
				 double *new_block_energies_array, 
				 double *sorted_new_block_energies_array); 



void transfer_quantum_operator(int symmetry_no, 
			       symmetry *symmetry_types,

			       int max_state_no, 
			       int new_block_state_no, 

			       state *  new_block_states_array, 
			       int  new_block_sector_no,

			       sector_properties *  new_block_sectors_properties_array, 
				 
			       int  block_state_no, 
			       state* block_states_array,

			       int  block_sector_no,
			       sector_properties * &block_sectors_properties_array,
				 
			       quantum_operator & one_operator,
			       quantum_operator & new_block_one_operator, 

			       double *new_block_energies_array, 
			       double *sorted_new_block_energies_array
			       ); 



void clear_new_block_states_and_sectors(state * & new_block_states_array,
					int new_block_sector_no, 
					sector_properties * & new_block_sectors_properties_array, 
					double * & new_block_energies_array,
					double * & sorted_new_block_energies_array,
					unsigned long * & new_block_energies_index,
					sector * & transformation_sectors); 

#endif // _cut_off_h_ 

