#include "../include/dmatrix.h"
#include "../include/in_out.h"
#include "../include/llvector.h"
#include "../include/sector.h"
#include "../include/state.h"
#include "../include/state_list.h"
#include "../include/symmetry.h"
#include "../include/variables.h"
#include "../include/quantum_operator.h"
#include "../include/construction.h"
#include "../include/diagonalization.h"
#include "../include/transformation.h"
#include "../include/cut_off.h"
#include "../include/spectral_function.h"
#include "../include/dmnrg.h"
#include "../include/mapping.h"
#include "../include/hilbert_transform.h"
#include "../include/density_of_states.h"
int main(){
  
  

  cout<<"Enter Lambda (double)(2.0, 2.5 etc):"<<endl;
  cin>>lambda; 
  
  cout<<"Enter iteration_no (int)(30, 40, 80 etc):"<<endl;
  cin>>iteration_no; 

  
  cout<<"Enter the number of hopping operator (hopping_operator_no)(integer):"<<endl;
  cin>>hopping_operator_no; 


  cout<<"Enter the number DOS points per interval(usually 1000-> 10000)(integer):"; 
  cin>>dos_points_no_per_interval; 
  

  cout<<"Wait for the calculation of the hopping parameters to be done..."<<endl;
  
 
  int self_consistancy_index = 0; 

  create_dos_mapping_folder(dos_mapping_folder_name);

  read_density_of_states();

  generate_initial_density_of_states(dos_points_no_per_interval,
				     self_consistancy_index,
				     hopping_operator_no); 

  generate_gamma_and_zeta(dos_points_no_per_interval,
			  self_consistancy_index, 
			  hopping_operator_no);

  
  generate_hoppings_and_on_site_energies(self_consistancy_index,
					 hopping_operator_no);

  remove_density_of_states_files();

  cout<<"Done"<<endl;

 
 
  return 1;
  
}//main 
