#include "../include/memory.h"


void clear_all_memory(){
     
     if (couplings) {
       delete [] couplings;
     }//if
     couplings = NULL;

     if (couplings_rescaled){
       delete [] couplings_rescaled;
     }
     couplings_rescaled = NULL;
     
     if (local_couplings) {
       delete [] local_couplings;
     }//if
     local_couplings = NULL;

     if (symmetry_types){
       for(int symmetry_index = 0; symmetry_index<symmetry_no; symmetry_index++){
	 symmetry_types[symmetry_index].clear();
       }//for       
     delete [] symmetry_types;
     }//if

     symmetry_types = NULL;
     
     block_hamiltonian.clear();
    
     if (block_hamiltonian_terms!= NULL){
       for(int i = 0; i<coupling_no; i++){
	 block_hamiltonian_terms[i].clear();
       }//for
       delete [] block_hamiltonian_terms;
     }

     block_hamiltonian_terms = NULL;

     if (local_hamiltonian_terms!= NULL){
       for(int i = 0; i<coupling_no; i++){
	 local_hamiltonian_terms[i].clear();
       }//for
       delete [] local_hamiltonian_terms;
     }

     local_hamiltonian_terms = NULL;
     
     if (local_hopping_hamiltonians !=NULL){
       for(int i=0; i<hopping_operator_no; i++){
	 local_hopping_hamiltonians[i].clear();
       }//for
       delete [] local_hopping_hamiltonians;
     }
     local_hopping_hamiltonians = NULL;

     if (new_block_spectral_operators != NULL){
       for(int i=0; i< spectral_operator_no; i++){
	 new_block_spectral_operators[i].clear();
       }//for
       delete [] new_block_spectral_operators;
     }
     new_block_spectral_operators = NULL;


     if (new_block_static_operators != NULL){
       for(int i=0; i< static_operator_no; i++){
	 new_block_static_operators[i].clear();
       }//for
       delete [] new_block_static_operators;
     }
     new_block_static_operators = NULL;

     if (new_block_hopping_operators != NULL){
       for(int i=0; i< hopping_operator_no; i++){
	 new_block_hopping_operators[i].clear();
       }//for
       delete [] new_block_hopping_operators;
     }
     new_block_hopping_operators = NULL;



     if (block_spectral_operators != NULL){
       for(int i=0; i< spectral_operator_no; i++){
	 block_spectral_operators[i].clear();
       }//for
       delete [] block_spectral_operators;
     }
     block_spectral_operators = NULL;


     if (block_static_operators != NULL){
       for(int i=0; i< static_operator_no; i++){
	 block_static_operators[i].clear();
       }//for
       delete [] block_static_operators;
     }
     block_static_operators = NULL;

     if (block_hopping_operators != NULL){
       for(int i=0; i< hopping_operator_no; i++){
	 block_hopping_operators[i].clear();
       }//for
       delete [] block_hopping_operators;
     }
     block_hopping_operators = NULL;


     if (local_hopping_operators != NULL){
       for(int i=0; i< hopping_operator_no; i++){
	 local_hopping_operators[i].clear();
       }//for
       delete [] local_hopping_operators;
     }
     local_hopping_operators = NULL;

     if (new_block_states_array != NULL){
       delete [] new_block_states_array;
     }
     new_block_states_array = NULL;

     if (new_block_sectors_properties_array != NULL){
       delete [] new_block_sectors_properties_array;
     }
     new_block_sectors_properties_array = NULL;
     

     if (local_states_array != NULL){
       delete [] local_states_array;
     }//if
     local_states_array = NULL;
     
     if (local_states_array_copy != NULL){
       delete [] local_states_array_copy;
     }
     local_states_array_copy = NULL;


       if (local_sectors_properties_array != NULL){
       delete [] local_sectors_properties_array;
     }
     local_sectors_properties_array = NULL;
     

     
     if (block_states_array != NULL){
       delete [] block_states_array;
     }//if
     block_states_array = NULL;


       
     if (block_states_array_copy != NULL){
       delete [] block_states_array_copy;
     }//if
     block_states_array_copy = NULL;


     if (block_sectors_properties_array != NULL){
       delete [] block_sectors_properties_array;
     }
     block_sectors_properties_array = NULL;
     
     
     if (new_block_energies_array != NULL){
       delete [] new_block_energies_array; 
     }
     new_block_energies_array = NULL;
     
   
     if (sorted_new_block_energies_array != NULL){
       delete [] sorted_new_block_energies_array; 
     }
     sorted_new_block_energies_array = NULL;
     

      if (block_energies_array != NULL){
       delete [] block_energies_array; 
     }
     block_energies_array = NULL;
     
      if (sorted_block_energies_array != NULL){
       delete [] sorted_block_energies_array; 
     }
     sorted_block_energies_array = NULL;
     
     if (new_block_energies_index != NULL){
       delete [] new_block_energies_index;
     }
     new_block_energies_index = NULL;


      if (block_energies_index != NULL){
       delete [] block_energies_index;
     }
     block_energies_index = NULL;


     if (hopping_couplings_array[0]){
       delete []( hopping_couplings_array[0]);
       hopping_couplings_array[0] = NULL;
     }
     if(hopping_couplings_array){
       delete []  hopping_couplings_array;
     }
     
     hopping_couplings_array = NULL;


     
     if (on_site_energies_array[0]){
       delete []( on_site_energies_array[0]);
       on_site_energies_array[0] = NULL;
     }
     if(on_site_energies_array){
       delete []  on_site_energies_array;
     }
     
     on_site_energies_array = NULL;



     delete []spectral_function_index[0]; 
     delete [] spectral_function_index[1]; 


  delete [] couplings_name; 
  couplings_name = NULL;



  if (block_original_sector_array){
    delete [] block_original_sector_array;
  }
  block_original_sector_array = NULL;

  if (block_original_sector_index_array){
    delete [] block_original_sector_index_array;
  }
  block_original_sector_index_array = NULL;

  return; 
}



