#if!defined (_density_of_states_h_)

#define _density_of_states_h_
#include <assert.h>
#include<fstream>
#include<iostream>
using namespace std;
#include <math.h>


#include "in_out.h"

double density_of_states_function(int hopping_operator_no,
				  int hopping_operator_index,
				  double energy);


extern double *dos_energy_array;
extern double **dos_hopping_operator_array; 
extern double **dos_hopping_operator_second_derivative_array; 
extern long dos_energy_no; 

extern "C" void splint(double xa[], double ya[], double y2a[], int n, double x, double *y);

#endif
