/****************************************************************************

Last Update : 2007/09/25 Pascu Moca 

No documentation update necessary


*****************************************************************************/


#include "../include/state_list.h"


/*----------------------------------------------------------------------------*/
/*---------------CONSTRUCTORS AND DESTRUCTORS---------------------------------*/
/*----------------------------------------------------------------------------*/


state_item::state_item(){

/*************************************************************************
class state_item:
this class represents a given state within a linked list of states.

members:
  state_item * next_ptr          - 
  friend class linked_state_list - 

Implicit constructor for the state_item class.

input variables = none

output variables  = none

return = none

What it does:
     set the 'next_ptr' to NULL.

how to call:
     state_item();
****************************************************************************/

  next_ptr = NULL;
}//state_item


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


state_item::~state_item(){

/****************************************************************************
Implicit destructor for the class.

input variables = none

output variables = none

return = none

What it does:
     Destroys the class state_item and set next_ptr to NULL.

how to call:
    ~state_item();
****************************************************************************/

  if(next_ptr){
    delete next_ptr;
  }//if
  next_ptr = NULL;
}//~state_item


/*----------------------------------------------------------------------------*/
/*---------------CONSTRUCTORS AND DESTRUCTORS---------------------------------*/
/*----------------------------------------------------------------------------*/

linked_state_list::linked_state_list(){
/*************************************************************************
class linked_state_list:
    represents a list of linked states.

members:
    first_ptr

Implicit constructor for the linked_state_list class.

input variables   = none

output variables  = none

return = none

What it does:
     set the 'first_ptr' to NULL.

how to call:
     linked_state_list();
****************************************************************************/

  first_ptr = NULL;  
}//linked_state_list


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


linked_state_list::~linked_state_list()	{

/****************************************************************************
Implicit destructor for the class.

input variables = none

output variables = none

return = none

What it does:
     Destroys the class state_item and set first_ptr to NULL.

how to call:
    ~linked_state_list();
****************************************************************************/

  if(first_ptr){
    delete first_ptr;
  }//if

  first_ptr = NULL;
  
}//~linked_state_list


/*----------------------------------------------------------------------------*/
/*-------------------MEMBERS FUNCTIONS----------------------------------------*/
/*----------------------------------------------------------------------------*/


void linked_state_list::add_state(state & next_state){

/****************************************************************************
input variables =one
      state & next_state - ??? 

output variables = none

return = void

What it does:
     ???
how to call:
     void add_state(state & next_state);
****************************************************************************/

  state_item * new_ptr = NULL;
  new_ptr = new state_item;
  new_ptr->new_state = next_state;
  new_ptr->next_ptr = first_ptr;
  first_ptr = new_ptr;

}//add_state


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


state & linked_state_list::get_state(state_item * ptr){

/****************************************************************************
input variables =one
      state_item * ptr - ??? 

output variables = none

return = state void

What it does:
     ???
how to call:
     state & get_state(state_item * ptr){
****************************************************************************/

  return ptr->new_state; 
}//get_state


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


state_item * linked_state_list::get_next_ptr(state_item * ptr){

/****************************************************************************
input variables =one
      state_item * ptr - ??? 

output variables = none

return = state void

What it does:
     ???
how to call:
     state_item * get_next_ptr(state_item * ptr){

****************************************************************************/

  return ptr->next_ptr;
}//get_next_ptr


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

